import 'package:collection/collection.dart';
import 'package:flutter/material.dart';

import '../../../../../api/marianumcloud/talk/getParticipants/getParticipantsResponse.dart';
import '../../../../../widget/userAvatar.dart';

class ParticipantsListView extends StatelessWidget {
  final GetParticipantsResponse participantsResponse;
  const ParticipantsListView(this.participantsResponse, {super.key});

  @override
  Widget build(BuildContext context) {
    // final participants = participantsResponse.data.map((participant) => ListTile(
    //   leading: UserAvatar(id: participant.actorId),
    //   title: Text(participant.displayName),
    //   subtitle: participant.statusMessage != null ? Text(participant.statusMessage!) : null,
    // )).toList();

    lastname(participant) => participant.displayName.toString().split(' ').last;
    
    final participants = participantsResponse.data
        .sorted((a, b) => lastname(a).compareTo(lastname(b)))
        .sorted((a, b) => a.participantType.index.compareTo(b.participantType.index));
    var groupedParticipants = participants.groupListsBy((participant) => participant.participantType);

    // Map<GetParticipantsResponseObjectParticipantType, List<GetParticipantsResponseObject>>

    return Scaffold(
      appBar: AppBar(
        title: const Text('Teilnehmende'),
      ),
      body: ListView(
        children: [
          ...groupedParticipants.entries.map((entry) => Column(
            children: [
              ListTile(
                title: Text(entry.key.prettyName),
                titleTextStyle: TextStyle(fontWeight: FontWeight.bold),
              ),
              ...entry.value.map((participant) => ListTile(
                leading: UserAvatar(id: participant.actorId),
                title: Text(participant.displayName),
                subtitle: participant.statusMessage != null ? Text(participant.statusMessage!) : null,
              )),
              Divider(),
            ],
          ))
        ],
      )
    );
  }
}
